"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.component = void 0;
const lit_html_1 = require("@rxdi/lit-html");
const hooks_core_1 = require("./hooks-core");
const component = (renderFn, { observedAttributes, shadowRoot, } = {}) => class extends HTMLElement {
    static get observedAttributes() {
        return observedAttributes || [];
    }
    connectedCallback() {
        if (shadowRoot) {
            this.attachShadow({ mode: 'open' });
        }
        this.render();
    }
    render() {
        (0, lit_html_1.render)((0, hooks_core_1.renderWithHooks)(this, renderFn, this.render.bind(this)), shadowRoot ? this.shadowRoot : this);
    }
    attributeChangedCallback(name, oldValue, newValue) {
        console.log(`Value ${name} changed from ${oldValue} to ${newValue}`);
    }
};
exports.component = component;
//# sourceMappingURL=element.js.map